;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;     461... ,   EEPROM  .
;    26 -    .
;
;#define tiny461
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
#ifdef tiny461
	.include "tn461def.inc"
#else
	.include "tn26def.inc"

	#define	SPL		SP
	#define	ACSRA	ACSR
	#define TCNT0L	TCNT0
	#define eearl	eear
	#define	TCCR0B	TCCR0
#endif
.LISTMAC
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
;  32 .
#define	VERSION	1, 0x0F, 0, 0x0F, 3, 2	; 1 0 32
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; :
;
; PA0: Uout / 10	  8 
; PA1: Iout		 8 
; PA2: Imax		8 ,   ,    Iout
; PA4: 	 10 
; PA5: Urectif / 20	 9 ?
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
.MACRO	SHR_W
	clc
	ror	@0H
	ror	@0L
.ENDMACRO
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
.MACRO	SHL_W
	clc
	rol	@0L
	rol	@0H
.ENDMACRO
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
.MACRO	LOAD_Z_FOR_LPM
	ldi	ZL, LOW(2*@0)
	ldi	ZH, HIGH(2*@0)
.ENDMACRO
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
.MACRO	InitAnaComp
	;     (     )
	sbi	ACSRA, ACD
.ENDMACRO
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
.MACRO	pushf
	in	sreg_copy, SREG
.ENDMACRO
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
.MACRO	popf
	out	SREG, sreg_copy
.ENDMACRO
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
.equ	IO_PORT		=PORTB
.equ	IO_DIR		=DDRB
.equ	I2C		=PORTB
.equ	I2C_DIR		=DDRB
.equ	I2C_IN		=PINB

.equ	SCL		=PORTB2
.equ	SDA		=PORTB0

;  usi
.equ	USI_DATA_END	=0
.equ	USI_WAIT_ACK	=1
.equ	USI_BIT_END	=3

.equ	POWER_PORT	=PORTA
.equ	POWER_DDR	=DDRA
.equ	POWER		=PORTA7

.equ	CHARGE_PORT	=PORTA
.equ	CHARGE_DDR	=DDRA
.equ	CHARGE		=PORTA6

.equ	BACKLIGHT_PORT	=PORTA
.equ	BACKLIGHT_DDR	=DDRA
.equ	BACKLIGHT	=PORTA3

.equ	COOLER_PORT	=PORTB
.equ	COOLER_DDR	=DDRB
.equ	COOLER		=PORTB6

.equ	LCD_ADDR	=0x70
.equ	TO_BE_CONTINUED	=0x80
;  
.equ	CMD_POINTER	=0x00
.equ	CMD_MODE_SET	=0x40
.equ	CMD_DEV_SELECT	=0x60
.equ	CMD_BLINK	=0x70
.equ	CMD_BANK_SELECT	=0x78
;   CMD_MODE_SET
.equ	MODE_STATIC	=0x01
.equ	MODE_MUX2	=0x02
.equ	MODE_MUX3	=0x03
.equ	MODE_MUX4	=0x00

.equ	MODE_1_3_BIAS	=0x00
.equ	MODE_1_2_BIAS	=0x04

.equ	MODE_LCD_ENABLE	=0x08
.equ	MODE_LCD_DISABLE=0x00

.equ	MODE_POWER_SAVE	=0x10
;   CMD_BLINK
.equ	MODE_BLINK_OFF	=0x00
.equ	MODE_BLINK_2HZ	=0x01
.equ	MODE_BLINK_1HZ	=0x02
.equ	MODE_BLINK_05HZ	=0x03

.equ	MODE_BLINK_ALT	=0x04
;     () 
.equ	MODE_INIT	=MODE_MUX2 | MODE_1_2_BIAS | MODE_LCD_ENABLE

;    
.equ	ADC_256V	=1 << REFS1	; 2.56,    ( PA3)
.equ	ADC_AVCC	=0		; AVCC
.equ	ADC_ADLAR	=1 << ADLAR
.equ	ADC_CK128	=0x07
.equ	ADMUX_INIT	=ADC_256V	; | ADC_ADLAR

;  :)
.equ	MINUS		=0x0B	;     
.equ	DEGREE		=0x0C
.equ	BLANK		=0x0F
.equ	DECIMAL		=0x01	;   ()

;     .
; 1, 2, 3..., 1 (2), 2 (2)...
;   16- .
;    : -   .
.equ	AVG_POINT	=5	;   
.equ	CHANNEL_DATA_SIZE	=2 + 2 + 2*AVG_POINT	;     

;    0
.equ	TIMER0_STOP	=0
.equ	TIMER0_CK_64	=3
.equ	TIMER0_CK_1024	=5
.equ	TIMER0_PRELOAD	=176

;    :)
.equ	PULLUP_DISABLE	=1 << PUD

;   
.equ	SLEEP_ENABLE	=1 << SE
.equ	SLEEP_ADC	=SLEEP_ENABLE | 1 << SM0
.equ	SLEEP_IDLE	=SLEEP_ENABLE

.equ	CHANNEL_LIMIT	=5	;    

;  
.equ	CHNL_U_OUT	=0
.equ	CHNL_I_OUT	=1
.equ	CHNL_I_MAX	=2
.equ	CHNL_TEMP	=3	; 
.equ	CHNL_RECTIF	=4	;   

;  RAM  0  9    LCD 
; 0 1 2 3 4 5 6 7 8 9
;   1 9.9     1.9 9
;.equ	LCD_START	=SRAM_START
.equ	U_POS		=1
.equ	I_POS		=6

; 0 1 2 3 4 5 6 7 8 9
;       1.9 9
.equ	I_MAX_POS	=3

; 0 1 2 3 4 5 6 7 8 9
;     6 5.5 3 6
.equ	P_POS		=2

; 0 1 2 3 4 5 6 7 8 9
; - 1 0 d     0.1 0 0
;   0 1 d   5 0.0 0 0
; 1 0 0 d   1 5 0.0 0
.equ	T_POS		=0
.equ	PD_POS		=5

; 0 1 2 3 4 5 6 7 8 9
;       5 1.2
.equ	U_RECT		=3

; 0 1 2 3 4 5 6 7 8 9
; 2     C A L I b r
; 2 S A V E d
.equ	CHNL_POS	=0
.equ	MSG_POS		=3

;    
.equ	LCD_LIM		=10

;     
.equ	LASTBIT		=3	;    
.equ	LASTBIT_MASK	=1 << LASTBIT
.equ	BTNS_PORT	=PINB	;   
.equ	BTN_MODE_PIN	=PINB3	;  ,     Mode
.equ	BTN_POWER_PIN	=PINB1	;  ,     Mode
.equ	BTN_MODE	=0	;  ,    
.equ	BTN_POWER	=2	;  ,    
.equ	BTN_MASK	=1 << BTN_MODE | 1 << BTN_POWER	; ,    ,  

;   :
.equ	VIEWMODE_U_I	=0	;     
.equ	VIEWMODE_I_MAX	=1	;     
.equ	VIEWMODE_P	=2	;  ,  
.equ	VIEWMODE_TPD	=3	;       
.equ	VIEWMODE_URECT	=5	;    
.equ	LASTMODE	=VIEWMODE_TPD	;    

;     
;       -     
.equ	VAL_CHANGE_THRESHOLD	=10

;      ,  ,     
.equ	RETURN_TIME	=200	;   10   ...  2  

;   
.equ	OVERHEAT_OFF	=937	;  90  (.   tcalc_bin.zip)
; ,      
.equ	OVERHEAT_ON	=668	;  40  (.   tcalc_bin.zip)
;  / 
.equ	COOLER_ON	=712	; 45 
.equ	COOLER_OFF	=668	; 40 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; 
.def	btn_mode_reg	=R0	;     Mode
.def	btn_power_reg	=R1	;     Power

.def	valL		=R2
.def	valH		=R3

.def	freq_k		=R4
.def	norm_factor	=R5

.def	return_timer	=R6	; ,         
.def	btns		=R7	;     
.def	btns_prev	=R8	;      
.def	mode		=R9	;   
.def	prev_mode	=R10	;     (   )

.def	sreg_copy	=R11
; ,   1, 2, 3, 4    .
;  1,  
.def	mc8u		=R16	;multiplicand
.def	mp8u		=R17	;multiplier
.def	m8uL		=R17	;result Low byte
.def	m8uH		=R18	;result High byte
.def	mcnt8u		=R19	;loop counter
;  1.5  16  
.def	mc16uL		=r16	;multiplicand low byte
.def	mc16uH		=r17	;multiplicand high byte
.def	mp16uL		=r18	;multiplier low byte
.def	mp16uH		=r19	;multiplier high byte
.def	m16u0		=r18	;result byte 0 (LSB)
.def	m16u1		=r19	;result byte 1

.def	m16u2		=r20	;result byte 2
.def	m16u3		=r21	;result byte 3 (MSB)
.def	mcnt16u		=r22	;loop counter


;  2,   
.def	temp1		=R16
.def	temp2		=R17
.def	odata		=R18
.def	sym		=R19
.def	pos		=R20

;  3,  
.def	drem16uL	=R14	; 
.def	drem16uH	=R15

.def	dres16uL	=R16	; 
.def	dres16uH	=R17
.def	dd16uL		=R16	; 
.def	dd16uH		=R17
.def	dv16uL		=R18	; 
.def	dv16uH		=R19
.def	dcnt16u		=R20

;  4,    BCD
.equ	AtBCD0		=13		;address of tBCD0
.equ	AtBCD2		=15		;address of tBCD1

.def	tBCD0		=R13		;BCD value digits 1 and 0
.def	tBCD1		=R14		;BCD value digits 3 and 2
.def	tBCD2		=R15		;BCD value digit 4
.def	fbinL		=R16		;binary value Low byte
.def	fbinH		=R17		;binary value High byte
.def	cnt16a		=R18		;loop counter
.def	tmp16a		=R19		;temporary value

;  
.def	adcvL		=R21	;   
.def	adcvH		=R22	;   
.def	param		=R23
.def	cnt		=R24

.def	channel_cnt	=R25	;  

;         
#define	dataL		XL	; R26
#define	dataH		XH	; R27
#define data		X

; ,             
#define	ptrL		YL	; R28
#define	ptrH		YH	; R29
#define	ptr		Y
;  
#define	qtrL		ZL	; R30
#define	qtrH		ZH	; R31
#define	qtr		Z
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
.CSEG
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;  .
reset:
	rjmp	main
	reti	; int0
	reti	; i/o pins
	rjmp	cmp1a	; timer 1 cmpa
	rjmp	cmp1b	; timer 1 cmpb
	rjmp	ovf1	; timer 1 ovf 1
	rjmp	timer0	; timer 0 ovf 0
	rjmp	usi_start
	rjmp	usi_ovf
	reti	; ee_ready
	reti	; ana_comp
;       (   ,  ).
	;pushf	;   
	in	adcvL, ADCL	;   in    
	in	adcvH, ADCH
	;popf	;   
	reti	; adc
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; 
cmp1a:	;        
	sbi	I2C, SCL
	ldi	temp1, 1
	nop		;   SCL     1
	sbis	I2C_IN, SCL	;   ,   ,    
	out	TCNT1, temp1	;   ,     
	reti	; (    20       )
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; 
cmp1b:	;     ,   set  
	sbic	I2C_IN, SDA	;   ,   
	rjmp	skip_ack
	set	;    (    9- )
	sbrc	param, USI_WAIT_ACK	;   9-  
	cbi	USIDR, 7	;         
skip_ack:
	cbi	I2C, SCL	;   ,   
	reti
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; 
ovf1:
	ldi	temp1, 1 << CTC1
	;    if else
	sbrc	param, USI_WAIT_ACK	;   9-  
	out	TCCR1B, temp1	;   1
	sbrs	param, USI_WAIT_ACK	;   9-  
	sbi	USICR, USICLK	;      :)

	ori	param, 1 << USI_BIT_END
	reti
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
usi_start:
	sbi	PORTA, PORTA6
	ldi	temp1, 20
sc_delay:	;  SDA  SCL    
	subi	temp1, 1
	brne	sc_delay

	cbi	I2C, SCL
	out	USIDR, odata	;      SDA
	sbi	I2C, SDA	;  SDA
	sbi	USISR, USISIF	;  start flag (      )
	cbi	PORTA, PORTA6
	reti
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
usi_ovf:
	sbi	USISR, USIOIF	;   
	sbi	USIDR, 7		;  SDA
	ori	param, 1 << USI_DATA_END	;  
	reti
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;   .        .
timer0:
	out	TCNT0L, freq_k
	reti
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;  .
main:
	;   
	ldi 	temp1, LOW(RAMEND)
	out 	SPL, temp1
#ifdef tiny461
	ldi 	temp1, HIGH(RAMEND)
	out 	SPH, temp1
#endif
	;   
	rcall	InitVars
	rcall	InitPorts
	InitAnaComp
	rcall	InitADC
	rcall	InitTimer0
	rcall	InitTimer1
	rcall	EnableTimers
	;  ,       
	sei
	rcall	InitI2CLCD

conv_loop:
	ldi	dataL, ADC_START	;       256 
	clr	dataH

point_loop:
	clr	channel_cnt

channel_loop:
	;   ( ,      ,      125   )
	rcall	SwitchADC		; 9
	rcall	IdleSleep		; ,   
	;     10,   80.000 .
	;   
	;  ,    (   adcvH:adcvL)
	rcall	RunAndReadADC		; 1664 ( 220  ,   10 )
	rcall	FindPrefferedMode	; 20     
	rcall	CheckChannelDelta	; 38
	rcall	ProcessReturnTimer	; 8   

	;    
	rcall	ReadBtns		; 44
	rcall	ProcessBtns		; 13+ (  / -   )

	cpi	channel_cnt, CHNL_TEMP	;         ;)
	brne	skip_check_temp
	rcall	CheckCooler		; ,     
	rcall	CheckOverheat		; 12 ( ,   ) ,      
skip_check_temp:
	;  ()   
	rcall	PushVal			;  :)

	;   
	inc	channel_cnt
	;   
	;subi	dataL, -2 -    PushVal

	;       
	cpi	channel_cnt, CHANNEL_LIMIT
	brne	channel_loop
;channel_loop

	;      10*5 = 50

	;       
	;   ,      ""
	;      -  
	rcall	ProcessUI
	;  - 
	; ,    20000 ,  2.5 (  )
	rcall	ShowSomething

	;       
	cpi	dataL, ADC_END
	brne	point_loop
;point_loop
	;      !
	rjmp	conv_loop
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;       .
;         .
; data =   
PushVal:
	;     
	st	data+, adcvL
	st	data+, adcvH
	;       ,   
	ldi	qtrL, ADC_START
	add	qtrL, channel_cnt	;   ...
	add	qtrL, channel_cnt	; 
	clr	qtrH

	;  
	clr	dd16uL
	clr	dd16uH
	ldi	cnt, AVG_POINT
sum_vals:	;     
	ld	adcvL, qtr
	ldd	adcvH, qtr + 1
	add	dd16uL, adcvL
	adc	dd16uH, adcvH
	subi	qtrL, -CHANNEL_LIMIT*2	;    
	subi	cnt, 1
	brne	sum_vals
	;       
	ldi	dv16uL, AVG_POINT
	clr	dv16uH
	rcall	div16u			; 251

	rcall	TruncVal

	;  
	ldi	param, norms
	add	param, channel_cnt
	rcall	EERead
	mov	norm_factor, param
	rcall	NormVal
	;   
	ldi	qtrL, NORM_VAL
	add	qtrL, channel_cnt	;   ...
	add	qtrL, channel_cnt	; 
	st	qtr+, m16u1
	st	qtr+, m16u2

	; 
	ret
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;         
;   ,        
;    -  ,   8  
;    -  10  (    )
TruncVal:
	; ,     
	cpi	channel_cnt, CHNL_U_OUT	;  tempX  ,     ,   dres16uX
	breq	trunc_2bit	;     ,    2 
	;        ...     1 
	cpi	channel_cnt, CHNL_RECTIF
	breq	trunc_1bit
	;   -  ,     
	ret
trunc_2bit:
	SHR_W	dres16u			;   
trunc_1bit:
	SHR_W	dres16u			;   

	ret
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;  .
;    :
;  dres16uX - ,    (,   mc16uX -   16  );
;  norm_factor -  ;
;  channel_cnt -  ,  .
NormVal:
	; ,    :
	; adc *= k (k ~= 128, 0 <= k <= 256)
	; adc *= 2
	; adc /= 256 (,     )
	mov	mp16uL, norm_factor
	clr	mp16uH
	rcall	mpy16u	; Achtung!    ,  adcvX

	clc
	rol	m16u0
	rol	m16u1
	rol	m16u2

	ret
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;     .
;     param,     ptr.
itoa:
	;  ,   > 100.
	clr		temp2
sub100_loop:
	cpi		param, 100
	brlo	sub100_stop
	subi	param, 100
	inc		temp2
	rjmp	sub100_loop
sub100_stop:
	st		ptr+, temp2
skip100:
	;  ,   > 10.
	clr		temp2
sub10_loop:
	cpi		param, 10
	brlo	sub10_stop
	subi	param, 10
	inc		temp2
	rjmp	sub10_loop
sub10_stop:
	st		ptr+, temp2
skip10:
	;   :)
	st		ptr+, param
	; .
	ret
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;    
StartI2C:
	cbi	I2C, SDA
	;         start condition
	ret
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;   
StopI2C:
	cbi	I2C, SDA	;   SDA,     0 - 1
	sbi	USIDR, 7	;            
	sbi	I2C, SCL	;  SCL

	ldi	temp1, 40
pc_delay:	;  SDA  SCL    
	subi	temp1, 1
	brne	pc_delay

	sbi	I2C, SDA	;  SDA,  ( )      stop condition
	ret
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;       ptr   cnt   I2C.
InternalOutBufToI2C:
	;      
	rcall	StartI2C
out_buf:	;  
	ld	odata, ptr+
	rcall	OutByteToI2C
	brtc	finish_transfer	;  T  ,  ,  
	subi	cnt, 1
	brne	out_buf
finish_transfer:
	;   
	rcall	StopI2C

	ret
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;     I2C
OutByteToI2C:
	ldi	temp1, 8
	out	USISR, temp1	; cnt = 8
	out	USIDR, odata

	;       = 1
	ldi	temp1, 1 << CS10 | 1 << CTC1
	out	TCCR1B, temp1	;   1
	;  1        +  
	clr	param
out_loop:	;    ,   
	sbrs	param, USI_DATA_END	; (  ,   8    )
	rjmp	out_loop	; 

	clt	;   
	ldi	param, 1 << USI_WAIT_ACK	; ,     ,       () 
ack_loop:	;   
	sbrs	param, USI_BIT_END
	rjmp	ack_loop

	cbi	USIDR, 7

	; ,     T       ACK
	ldi	temp1, 1
	out	TCNT1, temp1	;  ,     USI_FINISHED      

	ret
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;     .
OutBufToI2C:
	ldi	ptrH, 0
	ldi	ptrL, LCD_BUF - 3	;     CMD_BUF :)
	;   
	ldi	odata, LCD_ADDR
	st	ptr+, odata
	;  
	ldi	odata, CMD_DEV_SELECT | TO_BE_CONTINUED
	st	ptr+, odata
	;    
	ldi	odata, CMD_POINTER | 0
	st	ptr+, odata
	; ,   
	ldi	ptrL, LCD_BUF - 3
	ldi	cnt, LCD_LIM + 3	;     + 3   
	rcall	InternalOutBufToI2C

	ret
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
InitI2CLCD:
	ldi	ptrH, 0
	ldi	ptrL, LCD_BUF - 6	;     CMD_BUF :)
	;   
	ldi	odata, LCD_ADDR
	st	ptr+, odata
	;     
	ldi	odata, CMD_MODE_SET | MODE_INIT | TO_BE_CONTINUED
	st	ptr+, odata
	;  
	ldi	odata, CMD_DEV_SELECT | TO_BE_CONTINUED
	st	ptr+, odata
	;  
	ldi	odata, CMD_BANK_SELECT | TO_BE_CONTINUED
	st	ptr+, odata
	;   
	ldi	odata, CMD_BLINK | TO_BE_CONTINUED
	st	ptr+, odata
	;      0
	ldi	odata, CMD_POINTER | 0
	st	ptr+, odata
	;  
	rcall	ClrBuf
	; ,   
	ldi	ptrL, LCD_BUF - 6
	ldi	cnt, LCD_LIM + 6	;     + 6   
	rcall	InternalOutBufToI2C

	ret
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;  BCD  ,   
BCDTo7Seg:
EERead:
#ifdef tiny461
	sbic	eecr, eepe
#else
	sbic	eecr, eewe
#endif
	rjmp	EERead
	out		eearl, param
	sbi		eecr, eere
	in		param, eedr
	ret
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;   EEPROM
; : pos - , param - 
EEWrite:
#ifndef tiny461	;    :(
	sbic	EECR,EEWE	; if EEWE not clear
	rjmp	EEWrite		;     wait more

	out 	EEAR, pos	; output address low byte
	out	EEDR, param	; output data
	cli			; disable global interrupts	
	sbi 	EECR,EEMWE	; set master write enable, remove if 90S1200 is used	
	sbi	EECR,EEWE	; set EEPROM Write strobe
				; This instruction takes 4 clock cycles since
				; it halts the CPU for two clock cycles
	sei			; enable global interrupts
#endif
	ret
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;    ( ).
; !         FillBuf!!!
ClrBuf:
	ldi	param, 0
;       (param).
FillBuf:
	ldi	ptrL, LCD_BUF
	ldi	ptrH, 0
	clr	cnt
clr_buf:
	st	ptr+, param
	inc	cnt

	cpi	cnt, LCD_LIM
	brne	clr_buf

	ret
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;           (  ).
ConvertBuf:
	ldi	ptrL, LCD_BUF
	ldi	ptrH, 0
	clr	cnt
cnv_buf:
	ld	param, ptr
	rcall	BCDTo7Seg
	st	ptr+, param
	inc	cnt

	cpi	cnt, LCD_LIM
	brne	cnv_buf

	ret
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;      LCD.
; ,     ,    param.
SetDecimalPoint:
	ldi	ptrL, LCD_BUF
	add	ptrL, param
	ld	temp1, ptr
	ori	temp1, DECIMAL
	st	ptr, temp1

	ret
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;  .
; ADC Clock = 8.192.000 / 128 = 64.000
;     4807 ???
;   : 0.3
;    : 128*13 = 1664.
InitADC:
	ldi	temp1, ADC_CK128 | 1 << ADEN
	out	ADCSRA, temp1	;     
	ldi	temp1, ADMUX_INIT
	out	ADMUX, temp1
#ifdef tiny461
	ldi	temp1, 1 << REFS2
	out	ADCSRB, temp1
#endif
	ret
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
RunAndReadADC:
	;  
	sbi	ADCSRA, ADIF	; Alternatively, ADIF is cleared by writing a logical one to the flag.
	sbi	ADCSRA, ADIE	;  

	;ldi	temp1, SLEEP_IDLE | PULLUP_DISABLE ;  ,  ..., Pull-up disable
	;out	MCUCR, temp1
	;sleep
	rcall	IdleSleep

	;  ,      ,      
	cbi	ADCSRA, ADIE	;   

	ret
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
SwitchADC:
	ldi	temp2, ADC_256V	;       2.56
	cpi	channel_cnt, CHNL_TEMP	;     
	brne	skip_set_avcc
	ldi	temp2, ADC_AVCC	;     AVCC
skip_set_avcc:
	or	temp2, channel_cnt	;     
	out	ADMUX, temp2

	ret
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;* Number of cycles	:58 + return
mpy8u:
	clr	m8uH		;clear result High byte
	ldi	mcnt8u,8	;init loop counter
	lsr	mp8u		;rotate multiplier
	
m8u_1:
	brcc	m8u_2		;carry set 
	add 	m8uH,mc8u	;   add multiplicand to result High byte
m8u_2:
	ror	m8uH		;rotate right result High byte
	ror	m8uL		;rotate right result L byte and multiplier
	dec	mcnt8u		;decrement loop counter
	brne	m8u_1		;if not done, loop more

	ret
;***************************************************************************
;* Number of cycles	:153 + return
mpy16u:
	clr	m16u3		;clear 2 highest bytes of result
	clr	m16u2
	ldi	mcnt16u,16	;init loop counter
	lsr	mp16uH
	ror	mp16uL

m16u_1:	brcc	noad8		;if bit 0 of multiplier set
	add	m16u2,mc16uL	;add multiplicand Low to byte 2 of res
	adc	m16u3,mc16uH	;add multiplicand high to byte 3 of res
noad8:	ror	m16u3		;shift right result byte 3
	ror	m16u2		;rotate right result byte 2
	ror	m16u1		;rotate result byte 1 and multiplier High
	ror	m16u0		;rotate result byte 0 and multiplier Low
	dec	mcnt16u		;decrement loop counter
	brne	m16u_1		;if not done, loop more

	ret
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;* Number of cycles	:235/251 (Min/Max)
div16u:
	clr	drem16uL	;clear remainder Low byte
	sub	drem16uH,drem16uH;clear remainder High byte and carry
	ldi	dcnt16u,17	;init loop counter
d16u_1:
	rol	dd16uL		;shift left dividend
	rol	dd16uH
	dec	dcnt16u		;decrement counter
	brne	d16u_2		;if done
	ret					;    return
d16u_2:
	rol	drem16uL	;shift dividend into remainder
	rol	drem16uH
	sub	drem16uL,dv16uL	;remainder = remainder - divisor
	sbc	drem16uH,dv16uH	;
	brcc	d16u_3		;if result negative
	add	drem16uL,dv16uL	;    restore remainder
	adc	drem16uH,dv16uH
	clc			;    clear carry to be shifted into result
	rjmp	d16u_1		;else
d16u_3:
	sec			;    set carry to be shifted into result
	rjmp	d16u_1

	ret
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;* Number of cycles	:751/768 (Min/Max)
bin2BCD16:
	ldi	cnt16a,16	;Init loop counter	
	clr	tBCD2		;clear result (3 bytes)
	clr	tBCD1		
	clr	tBCD0		
	clr	ZH		;clear ZH (not needed for AT90Sxx0x)
bBCDx_1:lsl	fbinL		;shift input value
	rol	fbinH		;through all bytes
	rol	tBCD0		;
	rol	tBCD1
	rol	tBCD2
	dec	cnt16a		;decrement loop counter
	brne	bBCDx_2		;if counter not zero
	ret			;   return

bBCDx_2:ldi	r30,AtBCD2+1	;Z points to result MSB + 1
bBCDx_3:
	ld	tmp16a,-Z	;get (Z) with pre-decrement
	subi	tmp16a,-$03	;add 0x03
	sbrc	tmp16a,3	;if bit 3 not clear
	st	Z,tmp16a	;	store back
	ld	tmp16a,Z	;get (Z)
	subi	tmp16a,-$30	;add 0x30
	sbrc	tmp16a,7	;if bit 7 not clear
	st	Z,tmp16a	;	store back
	cpi	ZL,AtBCD0	;done all three?
	brne	bBCDx_3		;loop again if not
	rjmp	bBCDx_1		
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;  .   MC14490.
; : temp2 -  ,  T -  .
; ,  !
;
DebounceBtn:
	clr	temp1
	bld	temp1, LASTBIT		; t1[3] = T; // pin
	eor	temp1, temp2		; t1 = pin ^ btn_reg
	andi	temp1, LASTBIT_MASK	; t1 &= 0x08
	breq	debounce_reg		; if (t1 & 0x08) { //  ,  

	lsr	temp2			; 	btn_reg >>= 1;
	bld	temp2, 7		; 	btn_reg[7] = T; // pin
	rjmp	debounce_exit		; }

debounce_reg:				; else { // reg = last ? 0xF8 : 0
	bst	temp2, LASTBIT		; 	T = btn_reg[3]
	ldi	temp2, 0xFF		; 	btn_reg = 0xFF
	brts	debounce_exit		; 	if (last) // if (T != 1)
	clr	temp2                   ; 		btn_reg = 0;
					; }
debounce_exit:
	andi	temp2, 0xF8		; btn_reg &= 0xF8
	ret
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;   .   ,    .
ReadBtns:
	;  Mode
	in	temp1, BTNS_PORT	;    B
	com	temp1			;   ,    ,    == 0!!!
	bst	temp1, BTN_MODE_PIN	; T = PINB[BTN_MODE]; //  T =  B,   BTN_MODE
	mov	temp2, btn_mode_reg
	rcall	DebounceBtn		; 10 ...  =  T    temp2
	mov	btn_mode_reg, temp2

	;  Power
	in	temp1, BTNS_PORT	;    B
	com	temp1			;   ,    ,    == 0!!!
	bst	temp1, BTN_POWER_PIN	; T = PINB[BTN_POWER];
	mov	temp2, btn_power_reg
	rcall	DebounceBtn		; 10 ...  =  T    temp2
	mov	btn_power_reg, temp2

	; ,  -  ,  
	clr	btns			; ,    ...   

	ldi	temp1, 1 << BTN_MODE
	sbrc	btn_mode_reg, LASTBIT	;     ...    1 -     
	or	btns, temp1		; ,   

	ldi	temp1, 1 << BTN_POWER
	sbrc	btn_power_reg, LASTBIT	;     ...    1 -     
	or	btns, temp1		; ,   

	;  ,    btns    
	ret
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;  .
ProcessBtns:
	cp	btns, btns_prev		;     ?
	breq	not_changed		;  

	;  ... , ,  
	mov	btns_prev, btns		;    

	sbrs	btns, BTN_MODE		;     Mode
	rjmp	skip_btn_mode		;   ...   :)

	;   Mode...  - 

	; ,    
	in	temp1, POWER_PORT
	andi	temp1, 1 << POWER
	breq	skip_btn_mode		; ...     

	rcall	NextViewMode		;   
	rjmp	not_changed		;    ,     -  

skip_btn_mode:

	sbrs	btns, BTN_POWER		;   Power
	rjmp	skip_btn_power		;   ...   :)

	;   Power,    
	in	temp1, POWER_PORT	;   ,       
	sbrc	temp1, POWER	;   = 0,   
	rcall	PowerOff		;      
	sbrs	temp1, POWER	;   = 1,   
	rcall	PowerOn			;     

skip_btn_power:
not_changed:
	ret
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
PowerOn:
	sbi	BACKLIGHT_PORT, BACKLIGHT	;  
	rcall	OutVersion		;   

	sbi	CHARGE_PORT, CHARGE	;  
	rcall	Wait20ms		;  32,      (    20)
	rcall	Wait20ms
	sbi	POWER_PORT, POWER	;  
	rcall	WaitForCharge		;    
	cbi	CHARGE_PORT, CHARGE	;  

	rcall	Wait2s			;    ,     

	; ,      
	sbrc	btns, BTN_MODE		;  ,     
	rcall	CalibrateDevice		;    

skip_calibrate:
	rcall	WaitForBtnsRelease	;     (      )
	rcall	InitVars		;   ...
	ret
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
PowerOff:
	cbi	BACKLIGHT_PORT, BACKLIGHT	;  
	cbi	POWER_PORT, POWER	;  
	;rcall	WaitForBtnsRelease	; -  
	ret
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;         .
;     ,   ,   .
;     0  255.      0  4.
;      .    
; " ".
;  :
; param - da -         5 .
; valL - adc -    .
; da -     5 (, dt)
; adc -     (  1   da)
;   sym.
Bresenham:
	mov	odata, valL
	ldi	temp1, 5
	sub	param, temp1	; da -= dt

	clr	temp1		; d = 0
	clr	temp2
	clr	valL
	clr	valH
bres_loop:			; do {
	cp	temp1, valL	; 	if (d < 0)
	cpc	temp2, valH
	brmi	less_than_zero	;     then
				; 	else d -= 2*da
	sub	temp1, param	; 		d -= da
	sbc	temp2, valH
	sub	temp1, param	; 		d -= da
	sbc	temp2, valH
	rjmp	check_d
less_than_zero:			; 	then
	subi	temp1, LOW(-10)	; 		d += 2*dt	; LOW(-10)
	sbci	temp2, HIGH(-10)				; HIGH(-10)
check_d:
	cp	temp1, valL	; 	if (d >= 0)
	cpc	temp2, valH
	brmi	skip_inc_t
	inc	sym		; 		then t++
skip_inc_t:
	dec	odata		;	adc--
	tst	odata		;
	brne	bres_loop	; } while (adc > 0);
bres_exit:
	ret
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;   .
;   - valH:valL.
;   sym.
ConvertT:
	; ,   ,     ;)
	ldi	sym, MinT		;    
	ldi	qtrL, dADCtbl		;    
	clr	odata

	ldi	temp1, MinADC
	ldi	temp2, 0
	cp	valL, temp1
	cpc	valH, temp2
	brlo	t_conv_exit		; ,   
	;  >= FirstT,  .
t_conv_loop:
	mov	param, qtrL
	rcall	EERead			; param = *qtr
	add	temp1, param		; tblADC += dADC
	adc	temp2, odata		; odata == 0!!!
	cp	valL, temp1		; realADC < tblADC?
	cpc	valH, temp2
	brlo	range_founded		; ,    
	subi	sym, -5
	inc	qtrL			; ,     
	cpi	qtrL, dADCtblEnd
	brne	t_conv_loop
	;   ,   > 125 .
	ldi	sym, 125
	rjmp	t_conv_exit

range_founded:
	sub	temp1, param		;   ,     
	sbc	temp2, odata
	sub	valL, temp1		;      ,
	sbc	valH, temp2		;           
	breq	t_conv_exit		;     ,   
	rcall	Bresenham		;  valL     , param -  
	;     sym    .
t_conv_exit:
	ret
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
ProcessUI:
	ldi	ptrL, NORM_VAL + CHNL_I_OUT*2
	ld	dd16uL, ptr	;  
	clr	dd16uH
	ldi	dv16uL, 4*10	;  +  
	clr	dv16uH
	rcall	div16u		;    ,   = 1/4  +    1:10 :)
	ldi	ptrL, NORM_VAL + CHNL_U_OUT*2
	ld	temp2, ptr	;  
	sub	temp2, dres16uL	;      
	st	ptr, temp2	;   

	ret
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;        param.
OutBCD:
	;   : tBCD0 (0-1), tBCD1(2-3), tBCD2(4)
	;     LCD
	ldi	ptrL, LCD_BUF	;   
	add	ptrL, param

	mov	temp1, tBCD2	;  4
	andi	temp1, 0x0F
	cpi	temp1, 0		;     == 0,    ,  00.123  
	brne	skip_hide_zero
	ldi	temp1, BLANK
skip_hide_zero:
	st	ptr+, temp1

	mov	temp1, tBCD1	;  3
	swap	temp1
	andi	temp1, 0x0F
	st	ptr+, temp1
	mov	temp1, tBCD1	;  2
	andi	temp1, 0x0F
	st	ptr+, temp1

	mov	temp1, tBCD0	;  1
	swap	temp1
	andi	temp1, 0x0F
	st	ptr+, temp1
	mov	temp1, tBCD0	;  0
	andi	temp1, 0x0F
	st	ptr+, temp1

	ret
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;     20.
;  ,      100.
Wait20ms:
	;   
	out	TCNT0L, freq_k
	rcall	IdleSleep
	out	TCNT0L, freq_k
	rcall	IdleSleep

	ret
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;    2 .
Wait2s:
	ldi	temp2, 100		; 2000ms / 20ms = 100

wait_2s_loop:
	rcall	Wait20ms
	subi	temp2, 1
	brne	wait_2s_loop

	ret
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;     .
WaitForCharge:
	ldi	channel_cnt, CHNL_RECTIF
	rcall	SwitchADC
	rcall	RunAndReadADC

wait_charge_loop:
	; p = v
	mov	valL, adcvL
	mov	valH, adcvH
	; read v
	rcall	Wait20ms
	rcall	Wait20ms
	rcall	RunAndReadADC	;     
	; t = v
	mov	qtrL, adcvL
	mov	qtrH, adcvH
	; t -= p
	sub	qtrL, valL
	sbc	qtrH, valH
	; } while (t > 5);
	sbiw	qtrH:qtrL, 5
	brpl	wait_charge_loop

	ret
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;    (param)  . .      :)
SetViewMode:
	cp	mode, param			;       
	breq	reset_return_timer	;    

	cp	mode, prev_mode		;     ,    
	brne	already_in_auto_view

	mov	prev_mode, mode		;   
	mov	mode, param
	;   ,   
reset_return_timer:
	;     ,     
	ldi	temp1, RETURN_TIME
	mov	return_timer, temp1	;     :)

already_in_auto_view:
	ret
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;     .
NextViewMode:
	inc	mode			;   
	ldi	temp1, LASTMODE + 1 	; ,     
	cp	mode, temp1
	brlo	skip_mode_clear
	clr	mode
skip_mode_clear:
	mov	prev_mode, mode		;            
	ret
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;   .
ProcessReturnTimer:
	tst	return_timer		;   
	breq	skip_return_timer
	dec	return_timer
	brne	skip_return_timer	;    
	mov	mode, prev_mode		; 

skip_return_timer:
	ret
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
OutUI:
	ldi	ptrL, NORM_VAL + CHNL_U_OUT*2
	ld	param, ptr
	ldi	ptrL, LCD_BUF + U_POS	;   
	rcall	itoa

	ldi	ptrL, NORM_VAL + CHNL_I_OUT*2
	ld	param, ptr
	ldi	ptrL, LCD_BUF + I_POS	;   
	rcall	itoa

	;       
	rcall	ConvertBuf
	;   
	ldi	param, U_POS + 1
	rcall	SetDecimalPoint
	ldi	param, I_POS
	rcall	SetDecimalPoint

	ret
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
OutIMax:
	ldi	ptrL, NORM_VAL + CHNL_I_MAX*2
	ld	param, ptr
	ldi	ptrL, LCD_BUF + I_MAX_POS	;   
	rcall	itoa

	;       
	rcall	ConvertBuf
	;   
	ldi	param, I_MAX_POS
	rcall	SetDecimalPoint

	ret
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
OutP:
	ldi	ptrL, NORM_VAL + CHNL_U_OUT*2
	ld	mc8u, ptr
	ldi	ptrL, NORM_VAL + CHNL_I_OUT*2
	ld	mp8u, ptr
	rcall	mpy8u		;      m8uL:m8uH
	;   BCD
	mov	fbinL, m8uL	; R16 = R17
	mov	fbinH, m8uH	; R17 = R18
	rcall	bin2BCD16	;   1000  ,  , 1/8 * 1000 = 125
	ldi	param, P_POS
	rcall	OutBCD		;   BCD    

	;       
	rcall	ConvertBuf
	;   
	ldi	param, P_POS + 1
	rcall	SetDecimalPoint

	ret
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
OutTPD:
	rcall	OutT
	rcall	OutPDiss
	rcall	ConvertBuf
	; ,     OutPDiss 
	cpi	pos, 255
	breq	out_err
	;  ,    
	mov	param, pos
	rcall	SetDecimalPoint
	rjmp	out_tpd_exit
out_err:
	rcall	OutError
out_tpd_exit:
	ret
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
OutT:
	ldi	ptrL, NORM_VAL + CHNL_TEMP*2
	ld	valL, ptr+
	ld	valH, ptr+

	;      - 
	rcall	ConvertT
	clt		; T = 0
	tst	sym
	brpl	skip_temp_neg
	;   
	neg	sym
	set		; T = 1
skip_temp_neg:
	;   sym -  ,   T - 
	;     
	ldi	ptrL, LCD_BUF + T_POS	;   
	mov	param, sym
	rcall	itoa
	ldi	temp1, DEGREE
	st	ptr, temp1

	brtc	skip_out_minus
	ldi	temp1, MINUS	;    ""
	ldi	ptrL, LCD_BUF + T_POS	;     
	st	ptr, temp1
skip_out_minus:

	ret
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
OutPDiss:
	ldi	ptrL, NORM_VAL + CHNL_RECTIF*2	;    
	ld	valL, ptr+
	ld	valH, ptr

	ldi	ptrL, NORM_VAL + CHNL_U_OUT*2	;    
	ld	temp1, ptr+
	ld	temp2, ptr

	sub	valL, temp1	;      
	sbc	valH, temp2	; ,    25.6 (    51.2)
	brpl	skip_err	;       -  

	ldi	pos, 255	; ,  
	rjmp	out_pdiss_exit

skip_err:
	ldi	ptrL, NORM_VAL + CHNL_I_OUT*2	;  
	ld	dd16uL, ptr+	;    
	ld	dd16uH, ptr	;   2.56

	clt			; T = 0
	tst	valH		;     - ,   > 25.6
	breq	skip_div10	;     10,   - 

	clc          		;   2 
	ror	valH
	ror	valL

	set			;  T   ,     10

	ldi	dv16uL, 5	;   5 
	clr	dv16uH
	rcall	div16u		;   dres16uL,    dd16uL

skip_div10:
	mov	mp8u, valL	; 
	;mov	mc8u, dres16uL	;     ,     
	rcall	mpy8u		;      m8uL:m8uH

	;   BCD
	mov	fbinL, m8uL	; R16 = R17
	mov	fbinH, m8uH	; R17 = R18
	rcall	bin2BCD16	;   1000  ,  , 1/8 * 1000 = 125
	ldi	param, PD_POS
	rcall	OutBCD		;   BCD    

	;   
	ldi	pos, PD_POS + 1
	brtc	skip_mov_point	;    ,    
	inc	pos		;    
skip_mov_point:

out_pdiss_exit:
	ret
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; ,  !
OutURect:
	ldi	ptrL, NORM_VAL + CHNL_RECTIF*2
	ld	fBinL, ptr+
	ld	fBinH, ptr+
	rcall	bin2BCD16	;   1000  ,  , 1/8 * 1000 = 125
	ldi	param, U_RECT
	rcall	OutBCD		;   BCD    

	;       
	rcall	ConvertBuf
	;   
	ldi	param, U_RECT + 2
	rcall	SetDecimalPoint

	ret
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;    -       .
ShowSomething:
	;  
	rcall	ClrBuf

	; ,    
	sbis	POWER_PORT, POWER
	rjmp	end_of_show	; ...      

	ldi	param, BLANK
	rcall	FillBuf

	mov	qtrL, mode
	clr	qtrH
	subi	qtrL, LOW(-beg_switch)
	sbci	qtrH, HIGH(-beg_switch)
	icall	;      ,      jmp
	rjmp	end_of_show

beg_switch:
	rjmp	OutUI
	rjmp	OutIMax
	rjmp	OutP
	rjmp	OutTPD
	rjmp	OutURect

end_of_show:
	;    
	rcall	OutBufToI2C

	ret
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
InitTimer0:
	;   0
	ldi	param, freq
	rcall	EERead
	mov	freq_k, param	;    

	out	TCNT0L, freq_k		;   
#ifdef tiny461
	ldi	temp1, 0
	out	TCCR0A, temp1
#endif
	ldi	temp1, TIMER0_CK_1024
	out	TCCR0B, temp1

	ret
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
InitTimer1:
	; ,      20-
	ldi	temp1, 20
	out	OCR1A, temp1
	;     60-
	ldi	temp1, 60
	out	OCR1B, temp1
	;     1 = 81
	ldi	temp1, 80
	out	OCR1C, temp1
	;    ,    
	ret
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
EnableTimers:
	ldi	temp1, (1 << TOIE0) | (1 << TOIE1) | (1 << OCIE1A) | (1 << OCIE1B)
	out	TIMSK, temp1

	ret
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
InitVars:
	ldi	temp1, VIEWMODE_U_I
	mov	mode, temp1
	mov	prev_mode, mode
	clr	btns
	clr	btns_prev
	clr	return_timer
	clr	ptrL
	clr	ptrH
	clr	qtrL
	clr	qtrH
	clr	channel_cnt
	ldi	dataL, ADC_START	;       256 
	clr	dataH
	clr	btn_mode_reg	;    ,        
	clr	btn_power_reg

	ret
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
InitPorts:
	;  
	ldi	temp1, (1 << SDA) | (1 << SCL)
	out	I2C, temp1
	out	I2C_DIR, temp1
	; two-wire mode
	sbi	USIDR, 7	;    USI SDA   ,    ,   
	ldi	temp1, (1 << USIWM1) | (1 << USISIE) | (1 << USIOIE)
	out	USICR, temp1

	;      
	sbi	POWER_DDR, POWER
	sbi	CHARGE_DDR, CHARGE
	sbi	COOLER_DDR, COOLER
	sbi	BACKLIGHT_DDR, BACKLIGHT

	cbi	POWER_PORT, POWER	;   ,   
	cbi	CHARGE_PORT, CHARGE	;     
	cbi	COOLER_PORT, COOLER	;  
	cbi	BACKLIGHT_PORT, BACKLIGHT	;  

	ret
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;     .
;  ,     channel_cnt.
; ,     " "  param.
CheckChannelDelta:
	;    
	ldi	qtrL, LAST_VAL
	add	qtrL, channel_cnt	;   ...
	add	qtrL, channel_cnt	; 
	clr	qtrH
	; ,    
	ld	valL, qtr
	ldd	valH, qtr + 1
	; val -= adc;
	sub	valL, adcvL
	sbc	valH, adcvH
	brpl	rise
	; if (val < 0)
	;    val = -val;
	ldi	temp1, 0xFF
	com	valL
	com	valH
	sub	valL, temp1
	sbc	valH, temp1
rise:
	; ,    
	ldi	temp1, LOW(VAL_CHANGE_THRESHOLD)
	ldi	temp2, HIGH(VAL_CHANGE_THRESHOLD)
	cp	valL, temp1
	cpc	valH, temp2
	brlo	skip_mode_change
	;    
	rcall	SetViewMode	; 6

skip_mode_change:
	;       ,     
	cp	mode, param
	brne	check_channel_exit	;      (   VAL_CHANGE_THRESHOLD  )

	st	qtr+, adcvL	;   
	st	qtr+, adcvH
check_channel_exit:
	ret
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
CheckOverheat:
	ldi	temp1, LOW(OVERHEAT_OFF)
	ldi	temp2, HIGH(OVERHEAT_OFF)
	cp	adcvL, temp1
	cpc	adcvH, temp2
	brlo	check_exit
	;  
	rcall	PowerOff	;  
	rcall	OutOverHeat	;   
	rcall	Wait2s		;     
	;   :)
	cbi	BACKLIGHT_PORT, BACKLIGHT	;  
	rcall	Wait2s
	sbi	BACKLIGHT_PORT, BACKLIGHT	;  
	rcall	Wait2s
	cbi	BACKLIGHT_PORT, BACKLIGHT	;  
	rcall	Wait2s

	; "   " () ...
	ldi	channel_cnt, CHNL_TEMP
	rcall	SwitchADC
	rcall	RunAndReadADC
clr_and_wait_for_cold:
	;  
	ldi	ptrL, NORM_VAL + CHNL_TEMP*2
	st	ptr+, adcvL
	st	ptr+, adcvH
	;  
	ldi	param, BLANK
	rcall	FillBuf
	;  
	rcall	OutT	;     ADC_TEMP
	rcall	ConvertBuf
	rcall	OutBufToI2C
	;   ""
	clr	cnt
wait_for_cold:
	rcall	Wait2s
	rcall	RunAndReadADC

	ldi	temp1, LOW(OVERHEAT_ON)
	ldi	temp2, HIGH(OVERHEAT_ON)
	cp	adcvL, temp1
	cpc	adcvH, temp2
	brsh	clr_and_wait_for_cold	;   

	inc	cnt		; ...
	cpi	cnt, 5		;  
	brlo	wait_for_cold	;    5   ,  

check_exit:
	ret
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;   .
CheckCooler:
	sbic	COOLER_PORT, COOLER	;  ?
	rjmp	check_t_off		;     .
	;  . ,    .
	ldi	temp1, LOW(COOLER_ON)
	ldi	temp2, HIGH(COOLER_ON)
	cp	adcvL, temp1
	cpc	adcvH, temp2
	brlo	check_t_exit		;  ,    .

	sbi	COOLER_PORT, COOLER	;   !
	rjmp	check_t_exit

check_t_off:
	;  . ,     .
	ldi	temp1, LOW(COOLER_OFF)
	ldi	temp2, HIGH(COOLER_OFF)
	cp	adcvL, temp1
	cpc	adcvH, temp2
	brsh	check_t_exit		; ,  .    .

	cbi	COOLER_PORT, COOLER	;  .

check_t_exit:
	ret
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;        .
; : channel_cnt. : param.
FindPrefferedMode:
	mov	temp1, channel_cnt
	mov	param, mode	;    ,   

	cpi	temp1, CHNL_U_OUT
	brne	skip_u
	ldi	param, VIEWMODE_U_I
skip_u:
	cpi	temp1, CHNL_I_OUT
	brne	skip_i
	ldi	param, VIEWMODE_U_I
skip_i:
	cpi	temp1, CHNL_I_MAX
	brne	skip_i_max
	ldi	param, VIEWMODE_I_MAX
skip_i_max:
	cpi	temp1, CHNL_TEMP
	brne	skip_temp
	mov	param, mode	;     
skip_temp:
	ret
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;  ASCIIZ     .
; : qtr, cnt, : ptr.
;
strcpy:
	mov	param, qtrL
	rcall	EERead
	st	ptr+, param
	inc	qtrL
	dec	cnt
	tst	cnt
	brne	strcpy

	ret
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;     .
OutVersion:
	ldi	param, BLANK
	rcall	FillBuf

	ldi	qtrL, version_str
	ldi	ptrL, LCD_BUF + 2
	ldi	cnt, version_len
	rcall	strcpy
	rcall	ConvertBuf
	rcall	OutBufToI2C

	ret
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;     "OVErHEAt".
OutOverHeat:
	rcall	ClrBuf

	ldi	qtrL, overheat
	ldi	ptrL, LCD_BUF
	ldi	cnt, overheat_len
	rcall	strcpy
	rcall	OutBufToI2C

	sbi	BACKLIGHT_PORT, BACKLIGHT	;  

	ret
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;     "Error".
OutError:
	ldi	qtrL, err_msg
	ldi	ptrL, LCD_BUF + PD_POS
	ldi	cnt, err_msg_len
	rcall	strcpy
	rcall	OutBufToI2C

	ret
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
IdleSleep:
	;  
	ldi	temp1, SLEEP_IDLE | PULLUP_DISABLE ;  ,  ..., Pull-up disable
	out	MCUCR, temp1
	;    
	sleep	; (      ,     ,   )

	ret
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;   ""     .
LoadNorma:
	;     1:20     51.2 (512 )
	;       40
	ldi	qtrL, LOW(400)
	ldi	qtrH, HIGH(400)
	cpi	channel_cnt, CHNL_RECTIF
	breq	norma_founded
	;     10 ,  ,   1024 
	;       4
	ldi	qtrL, LOW(819)	; (4 / 5) * 1024 = 819
	ldi	qtrH, HIGH(819)
	cpi	channel_cnt, CHNL_TEMP
	breq	norma_founded
	;     25.6  2.56,  ,  256 
	;       20 (2.0...)
	ldi	qtrL, LOW(200)
	ldi	qtrH, HIGH(200)
norma_founded:
	ret
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;      .
AdjustNormFactor:
	cp	qtrL, m16u1
	cpc	qtrH, m16u2
	breq	not_required	; !
	brlo	dec_k
	;  ,   
	ldi	temp1, 0xC0
	cp	norm_factor, temp1	; ,         :)
	brsh	not_required
	inc	norm_factor
	ret
dec_k:	;  ,   
	ldi	temp1, 0x40
	cp	norm_factor, temp1	; ,       
	brlo	not_required
	dec	norm_factor
	ret

not_required:
	ret
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;  .
;   :
; U = adc*k;
; k = U / adc;
; :
;  channel_cnt -   
;  dres16uL:dres16uH -  ""  ,     mc16uL:mc16uH
;
CalcK:
	;     
	mov	valL, dres16uL
	mov	valH, dres16uH
	;     
	ldi	temp1, 0x80
	mov	norm_factor, temp1

	clr	cnt	;     

adjust_loop:
	mov	param, norm_factor	;  

	;   
	mov	dres16uL, valL
	mov	dres16uH, valH
	rcall	NormVal		;     m16u1:m16u2
	rcall	LoadNorma	;     qtrL:qtrH
	rcall	AdjustNormFactor;  
	cp	norm_factor, param	; ,   
	breq	k_founded	;  ,    :)
	brlo	check_dec

check_inc:
	;  , ,     
	cpi	cnt, -1
	breq	k_founded	;   ,   ,  
	ldi	cnt, 1		;   
	rjmp	adjust_loop
	
check_dec:
	;  , ,     
	cpi	cnt, 1
	breq	k_founded	;   ,   ,  
	ldi	cnt, -1		;   
	;    ,   
	rjmp	adjust_loop

k_founded:
	mov	param, norm_factor
	ldi	pos, norms
	add	pos, channel_cnt
	rcall	EEWrite

	ret
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;         .
;    10   .
SamplingChannel:
	clr	valL	;    
	clr	valH
	clr	cnt

point_loop2:
	rcall	IdleSleep

	rcall	RunAndReadADC	;  
	add	valL, adcvL	;  
	adc	valH, adcvH

	;   
	inc	cnt
	cpi	cnt, AVG_POINT
	brne	point_loop2
;point_loop2
	;  
	mov	dd16uL, valL
	mov	dd16uH, valH
	ldi	dv16uL, AVG_POINT
	clr	dv16uH
	rcall	div16u			; 251

	ret
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
DemoVal:
	ldi	param, BLANK
	rcall	FillBuf

	rcall	NormVal		;   (,  norm_factor        CalcK)

	;   BCD
	mov	fbinL, m16u1
	mov	fbinH, m16u2
	rcall	bin2BCD16	;   1000  ,  , 1/8 * 1000 = 125
	ldi	param, P_POS
	rcall	OutBCD		;   BCD    
	;       
	rcall	ConvertBuf
	;    
	rcall	OutBufToI2C	;   

	ret
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;       channel_cnt.
;  ,      .
;
NormChannel:
	rcall	SwitchADC	;    
	rcall	SamplingChannel
	rcall	TruncVal
	rcall	CalcK

	ret
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;    ,    .
;      param.
CalibrateChannel:
	rcall	WaitForBtnsRelease		;    

	mov	channel_cnt, param		;   
	rcall	ClrBuf				;  
	;   ,     
	ldi	ptrL, LCD_BUF + CHNL_POS	;   
	mov	param, channel_cnt
	subi	param, -chnl_name		;   param   - 
	rcall	EERead				;  
	st	ptr, param			;   

	ldi	qtrL, quest			;  ,    
	ldi	ptrL, LCD_BUF + MSG_POS
	ldi	cnt, quest_len
	rcall	strcpy
	rcall	OutBufToI2C			;     

	rcall	WaitForButtonPress		;   
check_norm_need:
	sbrc	btns, BTN_MODE			;     Mode
	rjmp	skip_channel_norm		;    
	;     (   Power)
norm_loop:
	rcall	WaitForBtnsRelease		; ,   
	rcall	NormChannel			;  

	rcall	ClrBuf
	ldi	qtrL, ack			;  
	ldi	ptrL, LCD_BUF + MSG_POS
	ldi	cnt, ack_len
	rcall	strcpy
	rcall	OutBufToI2C			;     
	rcall	Wait2s				;  2,     

demo_loop:					; -    
	rcall	SamplingChannel			;  
	rcall	TruncVal			;     
	rcall	DemoVal				;  
	rcall	ReadBtns			;    
	tst	btns				;   
	breq	demo_loop			;   - 
	rjmp	check_norm_need			;  ,   

skip_channel_norm:
	ret
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; ,  .
CalibrateDevice:
	;   
	ldi	param, CHNL_U_OUT
	rcall	CalibrateChannel
	;   
	ldi	param, CHNL_I_OUT
	rcall	CalibrateChannel
	;    
	ldi	param, CHNL_I_MAX
	rcall	CalibrateChannel
	;   
	ldi	param, CHNL_RECTIF
	rcall	CalibrateChannel
	;   
	ldi	param, CHNL_TEMP
	rcall	CalibrateChannel

	rcall	WaitForBtnsRelease		;    
	rcall	InitVars

	ret
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;    .
WaitForButtonPress:
	rcall	Wait20ms
	rcall	ReadBtns
	tst	btns
	breq	WaitForButtonPress
	ret
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
WaitForBtnsRelease:
	rcall	Wait20ms
	rcall	ReadBtns
	tst	btns
	brne	WaitForBtnsRelease
	ret
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
.DSEG
CMD_BUF:	.byte	6	;   ,        
LCD_BUF:	.byte	10	;   ,   
;     

;   AVG_POINT   
ADC_START:	.byte	AVG_POINT*CHANNEL_LIMIT*2
ADC_END:
LAST_VAL:	.byte	CHANNEL_LIMIT*2
NORM_VAL:	.byte	CHANNEL_LIMIT*2

STACK:		.byte	42	; 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
.ESEG
;  :)
;		0     1     2     3     4     5     6     7     8     9     E     "-"	
digits:	.db	0xEE, 0x44, 0xDA, 0xD6, 0x74, 0xB6, 0xBE, 0xE4, 0xFE, 0xF6, 0xBA, 0x10, 0xF0, 0, 0, 0, 1
;  (,   255) ...
;   ,      100
freq:	.db	TIMER0_PRELOAD
;       
; 0x80 == 1.00
norms:	.db	0x80, 0x80, 0x80, 0x80, 0x80

;         .
;  (RT)    R1 = 10000    GND.
;     Vcc.        RT  R1.
;   ,       
;     5 .
.equ	MinT	=-55	;     (  ,     )
.equ	MaxT	=125	;    
.equ	MinADC	=10	; ,   ,     

dADCtbl:
.db	 5,  6,  8, 11, 14, 18, 23, 28, 33, 39, 45, 49, 53, 56, 57, 57
.db	55, 52, 49, 44, 40, 36, 31, 28, 24, 20, 18, 15, 13, 12,  9,  9
.db	 7,  6,  5
dADCtblEnd:

;  
version_str:	.db	VERSION
version_str_end:
.equ	version_len	=version_str_end - version_str

;      (   ,    ConverBuf)
;			O V E r H E A t
overheat:	.db	0xEE, 0x6E, 0xBA, 0x18, 0x7C, 0xBA, 0xFC, 0x3A
overheat_end:
.equ	overheat_len	=overheat_end - overheat

;    'CALIbr'
quest:		.db	0xAA, 0xFC, 0x2A, 0x44, 0x3E, 0x18
quest_end:
.equ	quest_len	=quest_end - quest

;  'S A V E d'
ack:		.db	0xB6, 0xFC, 0x6E, 0xBA, 0x5E
ack_end:
.equ	ack_len		=ack_end - ack

;      
;			U     I     L     t     r
chnl_name:	.db	0x6E, 0x44, 0x2A, 0x3A, 0x18

;      E r r o r
err_msg:	.db	0xBA, 0x18, 0x18, 0x1E, 0x18
err_msg_end:
.equ	err_msg_len	=err_msg_end - err_msg
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
